/*
  Screen saver

  T. Nakagawa
  2011/04/17
*/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


#define SLEEP 5
#define WIDTH 132
#define HEIGHT 162


struct Bitmap {
  unsigned short bfType;
  unsigned int bfSize;
  unsigned short bfReserved1;
  unsigned short bfReserved2;
  unsigned int bfOffBits;

  unsigned int bV4Size;
  unsigned int bV4Width;
  unsigned int bV4Height;
  unsigned short bV4Planes;
  unsigned short bV4BitCount;
  unsigned int bV4Compression;
  unsigned int bV4SizeImage;
  unsigned int bV4XPelsPerMeter;
  unsigned int bV4YPelsPerMeter;
  unsigned int bV4ClrUsed;
  unsigned int bV4ClrImportant;
  unsigned int bV4RedMask;
  unsigned int bV4GreenMask;
  unsigned int bV4BlueMask;
};


int main(int argc, char **argv) {
  int i, n;
  FILE *fp;
  struct Bitmap header;
  unsigned short *bmp;

  if (argc != 2) return 1;

  if ((fp = fopen(argv[1], "r")) == NULL) return 1;
  if (fread(&header, sizeof(struct Bitmap), 1, fp) != 1) return 1;
  if (header.bfType != 0x4d42 ||
      header.bV4Width != WIDTH ||
      header.bV4Height % HEIGHT != 0 ||
      header.bV4Planes != 1 ||
      header.bV4BitCount != 16 ||
      header.bV4Compression != 3) {
    return 1;
  }
  if ((bmp = malloc(sizeof(char) * header.bV4SizeImage)) == NULL) return 1;
  fseek(fp, SEEK_SET, header.bfOffBits);
  if (fread(bmp, sizeof(char), header.bV4SizeImage, fp) != header.bV4SizeImage) return 1;

  n = header.bV4Height / HEIGHT;
  for (i = 0; ; i = (i + 1) % n) {
    fwrite("\x0e\x01", sizeof(char), 2, stdout);
    fwrite(bmp + WIDTH * HEIGHT * (n - 1 - i), sizeof(unsigned short), WIDTH * HEIGHT, stdout);
    fflush(stdout);
    sleep(SLEEP);
  }

  return 0;
}
